#include <bits/stdc++.h>

using namespace std;

int main()
{
    int n, k, x;
    cin >> n >> k >> x;
    int m [n - k + 1][k];
    int br [n];
    int rez[n - k + 1];
    for(int i = 0; i < n; i++){
        cin >> br[i];
    }
    for(int j = 0; j < k; j++){
        m[0][j] = br[n - k + j];
    }
    for(int i = 1; i < n - k + 1; i++){
        for(int j = k - 1; j >= 1; j--){
            m[i][j] = m[i - 1][j - 1] - m[i - 1][k - 1];
        }
        m[i][0] = br[n - i - 3] - m[i - 1][k - 1];
    }
    for(int i = 0; i < n - k + 1; i++){
        vector<int> v;
        for(int j = 1; j < k; j++){
            v.push_back(m[i][j]);
        }
        v.push_back(0);
        sort(v.begin(), v.end());
        int r = m[i][0];
        for(int c = 0; c < x - 1; c++){
            r += v[k - c - 1];
        }
        rez[i] = r;
        v.clear();
    }
    for(int i = n - k; i >= 0; i--){
        cout << rez[i] << " ";
    }
    return 0;
}